#region License Information
/* HeuristicLab
 * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion

using System;
using System.Collections.Generic;
using System.Text;

namespace HeuristicLab.Core {
  /// <summary>
  /// Event arguments to be able to specify the affected item.
  /// </summary>
  public class ItemEventArgs : EventArgs {
    private IItem myItem;
    /// <summary>
    /// Gets the affected item.
    /// </summary>
    public IItem Item {
      get { return myItem; }
    }

    /// <summary>
    /// Initializes a new instance of <see cref="ItemEventArgs"/> with the given <paramref name="item"/>.
    /// </summary>
    /// <param name="item">The affected item.</param>
    public ItemEventArgs(IItem item) {
      myItem = item;
    }
  }
}
